#Start of Solution to Question 1
def computeSum(n):
  S = n*(n+1)/2
  return S
#End of Solution to Question 1


#Start of Alternative Solution to Question 1
#def computeSum(n):
#  S = 0
#  for i in range(1, n+1, 1):
#    S = S + i
#  return S
#End of Alternative Solution to Question 1


#Start of Solution to Question 2
def computePartialSum(n1, n2):
  S = computeSum(n2) - computeSum(n1-1)
  print "Partial sum = ", S
#End of Solution to Question 2


#Start of Solution to Question 3 (you may test using cartoon-cow.jpg)
def convertTo2ColorImage():
  image = makePicture(pickAFile())
  allPixels = getPixels(image)
  for pixel in allPixels:
    r = getRed(pixel)
    g = getGreen(pixel)
    b = getBlue(pixel)
    if(r>127 or g>127 or b>127):
      color = white
    else:
      color = black
    pixel.setColor(color)
  show(image)
#End of Solution to Question 3


#Start of Solution to Question 4 (you may test using bird.jpg)
def rotate90Degrees(image):
  width = getHeight(image)
  height = getWidth(image)
  rotatedImage = makeEmptyPicture(width, height)
  for i in range(1, height+1, 1):
    for j in range(1, width+1, 1):
      pixel = getPixel(image, i, j)
      color = getColor(pixel)
      pixel = getPixel(rotatedImage, width+1-j, i)
      setColor(pixel, color)
  return rotatedImage
#End of Solution to Question 4


#Start of Solution to Question 5 (you may test using bird.jpg)
def rotate180Degrees():
  image = makePicture(pickAFile())
  image = rotate90Degrees(image)
  image = rotate90Degrees(image)
  show(image)
#End of Solution to Question 5


#Start of Solution to Question 6 (you may test using bird.jpg)
def flipHorizontally():
  image = makePicture(pickAFile())
  height = getHeight(image)
  width = getWidth(image)
  flippedImage = makeEmptyPicture(width, height)
  for i in range(1, width+1, 1):
    for j in range(1, height+1, 1):
      pixel = getPixel(image, i, j)
      color = getColor(pixel)
      pixel = getPixel(flippedImage, width+1-i, j)
      setColor(pixel, color)
  show(flippedImage)
#End of Solution to Question 6


#Description: You will use the following function to answer questions 7(a-h).
def drawSmileyFace():
  face = makeEmptyPicture(400, 400, white)
  for j in range(1, 401, 40):
    for i in range(1, 401, 80):
      if (j/40) % 2 == 1:
        face.addRectFilled(black, i, j, 40, 40)
      else:
        face.addRectFilled(black, i+40, j, 40, 40)  
  #Start of Solution to Question 7
  face.addOvalFilled(yellow, 100, 100, 200, 200)     #7(a)
  face.addOval(black, 100, 100, 200, 200)            #7(b)
  face.addOvalFilled(black, 150, 150, 30, 40)        #7(c)
  face.addOvalFilled(black, 220, 150, 30, 40)        #7(d)
  face.addOvalFilled(black, 150, 200, 100, 65)       #7(e)
  face.addOvalFilled(yellow, 150, 180, 100, 50)      #7(f)
  face.addOvalFilled(red, 180, 180, 40, 40)          #7(g)
  face.addText(blue, 150, 140, "Happy Halloween!")   #7(h)
  #End of Solution to Question 7  (you can see the resulting image in drawn-by-q7.jpg)
  show(face)


#Description: You will use the following function to answer questions 8(a-e).
def printProduct(start, end):
  product = 1
  factor = 1
  for n in range(start, end+1, 1):
    if computeSum(n)%2 == 1:
      factor = factor + 1
    else:
      factor = factor - 1
    product = product * factor
  print product * factor


#Solution to Question 8(a): The final values of product and factor will be 20736 and 2 respectively.


#Solution to Question 8(b): The if-block will be executed 8 times.


#Solution to Question 8(c): factor = factor + 1


#Solution to Question 8(d): The else-block will be executed 7 times.


#Solution to Question 8(e): factor = factor - 1
